/******************************************************************************
 * Copyright 2022-2023 TypeFox GmbH
 * This program and the accompanying materials are made available under the
 * terms of the MIT License, which is available in the project root.
 ******************************************************************************/
import { AstNode } from "langium";
import { Type, SelectTableExpression } from "./generated/ast";
import { RowTypeDescriptor, TypeDescriptor } from "./sql-type-descriptors";
import { BinaryOperator, UnaryOperator } from "./sql-type-operators";
export type ComputeTypeFunction = (node: AstNode) => TypeDescriptor | undefined;
export declare function computeType(node: AstNode): TypeDescriptor | undefined;
export declare function computeTypeOfSelectStatement(selectStatement: SelectTableExpression): RowTypeDescriptor;
export declare function computeTypeOfDataType(dataType: Type): TypeDescriptor | undefined;
export declare function computeTypeOfNumericLiteral(text: string): TypeDescriptor | undefined;
export declare function computeTypeOfBinaryOperation(operator: BinaryOperator, left: TypeDescriptor, right: TypeDescriptor): TypeDescriptor | undefined;
export declare function computeTypeOfUnaryOperation(operator: UnaryOperator, operandType: TypeDescriptor): TypeDescriptor | undefined;
